"""
This file contains examples of Identify API usage.
"""
from datetime import datetime
from uuid import UUID

from jarvis_proto_sdk.cmd import IdentityClient


def introspect_token_example():
    token = "JWT TOKEN"
    client = IdentityClient()
    token_info = client.introspect_token(token)
    if token_info is not None:
        print("Token info")
        print("Tenant: " + str(UUID(bytes=token_info.tenant_id)))
        print("Customer: " + str(UUID(bytes=token_info.customer_id)))
        print("App space: " + str(UUID(bytes=token_info.app_space_id)))
        print("Application: " + str(UUID(bytes=token_info.application_id)))
        print("Subject: " + str(UUID(bytes=token_info.subject_id)))
        print("Expire time: " + str(datetime.fromtimestamp(token_info.expire_time.seconds)))


def verify_digital_twin_email_example():
    token = "VERIFICATION TOKEN FROM TEMPORAL"
    client = IdentityClient()
    digital_twin_info = client.verify_digital_twin_email(token)
    if digital_twin_info is not None:
        print("Digital twin info")
        print("Tenant: " + str(UUID(bytes=digital_twin_info.tenant_id)))
        print("Digital twin: " + str(UUID(bytes=digital_twin_info.digital_twin_id)))
